package
{
	import com.pokkt.plugin.AdConfig;
	import com.pokkt.plugin.PokktConfig;
	import com.pokkt.plugin.PokktManager;
	import com.pokkt.plugin.utilities.AdFormat;
	import com.pokkt.plugin.utilities.PokktEvent;
	
	import flash.display.StageAspectRatio;
	
	import starling.display.Button;
	import starling.events.Event;
	import starling.text.TextField;
	
	public class PlayVideoScreen extends BaseScreen
	{
		[Embed(source="assets/button1.png")]
		public static const BUTTON1:Class;
		
		[Embed(source="assets/button2.png")]
		public static const BUTTON2:Class;
		
		private var _btnCacheVideo:Button;
		private var _btnCacheInterstitial:Button;
		private var _btnShowVideo:Button;
		private var _btnShowInterstitial:Button;
		private var _btnExportLogs:Button;
		private var _txtEarnedPoint:TextField;
		private var _txtInfo:TextField;
		private var _txtScreenName:TextField;
		private var _yPadding:int = 15;
		private var _totalEarnedPoint:Number = 0.0;
		private var _callback:Function;
		
		private var _pokktConfig:PokktConfig;
		private var _screenName:String = "";
		private var _isRewarded:Boolean = false;
		private var _adConfig:AdConfig;
		
		public function PlayVideoScreen(callback:Function, screenName:String, isRewarded:Boolean)
		{
			super();
			
			_callback = callback;
			_screenName = screenName;
			_isRewarded = isRewarded;
			
			_imgLogo.y = _imgLogo.y/2;
			
			_txtScreenName = GetUIComponent.getTextField("Points earned: 0", 14 / Constants.ContentScaleFactor, false);
			_txtScreenName.x = 10 * Constants.X_SCALE;
			_txtScreenName.y = _imgLogo.y  +_imgLogo.height;
			_txtScreenName.text = "Screen Name: " + screenName;
			addChild(_txtScreenName); 
			
			_txtEarnedPoint = GetUIComponent.getTextField("Points earned: 0", 14 / Constants.ContentScaleFactor, false);
			_txtEarnedPoint.x = 10 * Constants.X_SCALE;
			_txtEarnedPoint.y = _txtScreenName.y  +_txtScreenName.height;
			addChild(_txtEarnedPoint);
			
			_txtInfo = GetUIComponent.getTextField("", 13 / Constants.ContentScaleFactor, false);
			_txtInfo.x = 10 * Constants.X_SCALE;
			_txtInfo.y = _txtEarnedPoint.y  +_txtEarnedPoint.height + _yPadding/2 * Constants.Y_SCALE;
			addChild(_txtInfo);
			
			_btnCacheVideo = GetUIComponent.getButton(BUTTON1, "Start Video Caching", 10);
			_btnCacheVideo.y = _txtInfo.y + _txtInfo.height + _yPadding * Constants.Y_SCALE;
			_btnCacheVideo.addEventListener(Event.TRIGGERED, onCacheVideoClicked);
			addChild(_btnCacheVideo);
			
			var btnTxt:String;
			if(isRewarded)
				btnTxt = "Show Incent Video(without caching)";
			else
				btnTxt = "Show Non-Incent Video(without caching)";
			
			_btnShowVideo = GetUIComponent.getButton(BUTTON2, btnTxt, 10);
			_btnShowVideo.y = _btnCacheVideo.y + _btnCacheVideo.height + _yPadding * Constants.Y_SCALE;
			_btnShowVideo.addEventListener(Event.TRIGGERED, onShowVideoClicked);
			addChild(_btnShowVideo);
			
			_btnCacheInterstitial = GetUIComponent.getButton(BUTTON1, "Start Interstitial Caching", 10);
			_btnCacheInterstitial.y = _btnShowVideo.y + _btnShowVideo.height + _yPadding * Constants.Y_SCALE;
			_btnCacheInterstitial.addEventListener(Event.TRIGGERED, onCacheInterstitialClicked);
			addChild(_btnCacheInterstitial);
			
			if(isRewarded)
				btnTxt = "Show Non-Incent Interstitial(without caching)";
			else
				btnTxt = "Show Incent Interstitial(without caching)";
			
			_btnShowInterstitial = GetUIComponent.getButton(BUTTON2, btnTxt, 10);
			_btnShowInterstitial.y = _btnCacheInterstitial.y + _btnCacheInterstitial.height + _yPadding * Constants.Y_SCALE;
			_btnShowInterstitial.addEventListener(Event.TRIGGERED, onShowInterstitialClicked);
			addChild(_btnShowInterstitial);
			
			_btnExportLogs = GetUIComponent.getButton(BUTTON2, "Export Logs", 10);
			_btnExportLogs.y = _btnShowInterstitial.y + _btnShowInterstitial.height + (_yPadding*2) * Constants.Y_SCALE;
			addChild(_btnExportLogs);
			_btnExportLogs.addEventListener(Event.TRIGGERED, onExportLogsClicked);
			
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_AVAILABILITY_STATUS_EVENT, onAdAvailability);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_CACHING_COMPLETED_EVENTS, onAdCachingCompleted);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_CACHING_FAILED_EVENTS, onAdCachingFailed);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_CLOSED_EVENTS, onAdClosed);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_COMPLETED_EVENTS, onAdCompleted);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_SKIPPED_EVENTS, onAdSkipped);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_DISPLAYED_EVENTS, onAdDisplayed);
			PokktManager.dispatcher.addEventListener(PokktEvent.AD_GRATIFIED_EVENTS, onAdGratified);
		}
		
		private function showButton(rewardValue:Number, isAdAvailable:Boolean, adConfig:AdConfig):void
		{
			if(isAdAvailable) 
			{
				if(adConfig.adFormat == AdFormat.INTERSTITIAL)
					_btnShowInterstitial.enabled = true;
				else if(adConfig.adFormat == AdFormat.VIDEO)
					_btnShowVideo.enabled = true;
				
				if(_isRewarded)
				{
					if(adConfig.adFormat == AdFormat.INTERSTITIAL)
						_btnShowInterstitial.text = "Show Incent Ad To Earn " + rewardValue + " (Cached)";
					else if(adConfig.adFormat == AdFormat.VIDEO)
						_btnShowVideo.text = "Show Incent Ad To Earn " + rewardValue + " (Cached)";
				} 
				else
				{
					if(adConfig.adFormat == AdFormat.INTERSTITIAL)
						_btnShowInterstitial.text = "Show Non-Incent Ad To Earn " + rewardValue + " (Cached)";
					else if(adConfig.adFormat == AdFormat.VIDEO)
						_btnShowVideo.text = "Show Non-Incent Ad To Earn " + rewardValue + " (Cached)";
				}
			}
		}
		
		private function resetButton(adConfig:AdConfig):void
		{
			_btnShowVideo.enabled = true;
			_btnCacheVideo.enabled = true;
			
			_btnShowInterstitial.enabled = true;
			_btnCacheInterstitial.enabled = true;
			
			if(adConfig.isRewarded) { 
				if(adConfig.adFormat == AdFormat.INTERSTITIAL)
					_btnShowInterstitial.text = "Show Non-Rewarded (without caching)";
				else if(adConfig.adFormat == AdFormat.VIDEO)
					_btnShowVideo.text = "Show Non-Rewarded (without caching)";
			}
			else {
				if(adConfig.adFormat == AdFormat.INTERSTITIAL)
					_btnShowInterstitial.text = "Show Rewarded (without caching)";
				else if(adConfig.adFormat == AdFormat.VIDEO)
					_btnShowVideo.text = "Show Rewarded (without caching)";
			}
		}
		
		private function showAd(isAdAvailable:Boolean, adConfig:AdConfig):void
		{
			if(isAdAvailable)
			{
				PokktManager.showAd(adConfig);
			}
		}
		
		//Button click functions
		
		protected function onCacheVideoClicked(event:Event):void
		{
			_btnShowVideo.enabled = false;
			_btnCacheVideo.enabled = false;
			
			_adConfig = new AdConfig();
			_adConfig.screenName = _screenName;
			_adConfig.isRewarded = _isRewarded;
			_adConfig.defaultSkipTime = 5;
			_adConfig.backButtonDisabled = false;
			_adConfig.adFormat = AdFormat.VIDEO;
			PokktManager.cacheAd(_adConfig);
		}
		
		protected function onCacheInterstitialClicked(event:Event):void
		{
			_btnShowInterstitial.enabled = false;
			_btnCacheInterstitial.enabled = false;
			
			_adConfig = new AdConfig();
			_adConfig.screenName = _screenName;
			_adConfig.isRewarded = _isRewarded;
			_adConfig.defaultSkipTime = 5;
			_adConfig.backButtonDisabled = false;
			_adConfig.adFormat = AdFormat.INTERSTITIAL;
			PokktManager.cacheAd(_adConfig);
		}
		
		protected function onShowVideoClicked(event:starling.events.Event):void
		{
			_btnShowVideo.enabled = false;
			_btnCacheVideo.enabled = false;
			
			if(!_adConfig)
			{
				_adConfig = new AdConfig();
				_adConfig.screenName = _screenName;
				_adConfig.isRewarded = _isRewarded;
				_adConfig.defaultSkipTime = 5;
				_adConfig.backButtonDisabled = false;
			}
			_adConfig.adFormat = AdFormat.VIDEO;
			PokktManager.checkAdAvailability(_adConfig);
		}
		
		protected function onShowInterstitialClicked(event:starling.events.Event):void
		{
			_btnShowInterstitial.enabled = false;
			_btnCacheInterstitial.enabled = false;
			
			if(!_adConfig)
			{
				_adConfig = new AdConfig();
				_adConfig.screenName = _screenName;
				_adConfig.isRewarded = _isRewarded;
				_adConfig.defaultSkipTime = 5;
				_adConfig.backButtonDisabled = false;
			}
			_adConfig.adFormat = AdFormat.INTERSTITIAL;
			PokktManager.checkAdAvailability(_adConfig);
		}
		
		private function onExportLogsClicked():void
		{
			PokktManager.exportLog();
		}
		
		protected function onAdCachingCompleted(event:PokktEvent):void
		{
			trace("onAdCachingCompleted: " + event.adConfig);
			showButton(event.rewardValue, event.isAdAvailable, event.adConfig);
		}
		
		protected function onAdCachingFailed(event:PokktEvent):void
		{
			trace("onAdCachingFailed: " + event.adConfig);
			showButton(event.rewardValue, event.isAdAvailable, event.adConfig);
			resetButton(event.adConfig);
		}
		
		protected function onAdAvailability(event:PokktEvent):void
		{
			trace("onAdAvailability called: " + event.isAdAvailable);
			if(event.isAdAvailable)
			{
				showButton(event.rewardValue, event.isAdAvailable, event.adConfig);
				showAd(event.isAdAvailable, event.adConfig);
			}
			else
			{
				resetButton(event.adConfig);
			}
		}
		
		protected function onAdGratified(event:PokktEvent):void
		{
			trace("onAdGratified: rewardValue: " + event.rewardValue);
			_totalEarnedPoint = _totalEarnedPoint + event.rewardValue;
			_txtEarnedPoint.text = "Points earned: "  + _totalEarnedPoint;
		}
		
		protected function onAdDisplayed(event:PokktEvent):void
		{
			//Constants.STAGE.setAspectRatio(StageAspectRatio.LANDSCAPE);
			trace("onAdDisplayed: ", event.adConfig);
		}
		
		protected function onAdSkipped(event:PokktEvent):void
		{
			trace("onAdSkipped");
		}
		
		protected function onAdCompleted(event:PokktEvent):void
		{
			trace("onAdCompleted");
		}
		
		protected function onAdClosed(event:PokktEvent):void
		{
			Constants.STAGE.setAspectRatio( StageAspectRatio.PORTRAIT );
			resetButton(event.adConfig);
		}
		
		//Dispose method
		override public function dispose():void
		{
			super.dispose();
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_AVAILABILITY_STATUS_EVENT, onAdAvailability);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_CACHING_COMPLETED_EVENTS, onAdCachingCompleted);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_CACHING_FAILED_EVENTS, onAdCachingFailed);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_CLOSED_EVENTS, onAdClosed);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_COMPLETED_EVENTS, onAdCompleted);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_SKIPPED_EVENTS, onAdSkipped);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_DISPLAYED_EVENTS, onAdDisplayed);
			PokktManager.dispatcher.removeEventListener(PokktEvent.AD_GRATIFIED_EVENTS, onAdGratified);
		}
	}
}